export const Self = Symbol()
export const Value = Symbol()

export function constant() { return this }

/**
 * @template T, U
 * @typedef {(x: T) => U} Morphism
 */

/**
 * @template T
 * @typedef {{ [Value]: T }} Set
 */

/**
 * @template T
 * @typedef {{ [Self]: (value: T) => Applicative<T> }} Applicative
 */

/**
 * @template T
 * @param {T} value
 * @returns {Set<T>}
 */
export const Set = value => ({ [Value]: value })

/**
 * @template T, U
 * @param {Morphism<T, U>} fn 
 * @returns {U}
 */
export function chain(fn) {
  return fn(this[Value])
}

export function extract() {
  return this[Value]
}


/**
 * @template T
 * @this {Applicative<T>}
 * @param {T} value 
 * @returns {Applicative<T>}
 */
export function of(value) {
  return this[Self](value)
}

